%%  Display and detail enhancement for high-dynamic-range infrared images
% This algorithm is a simpfied verison of DDE algorithm in [1].
% [1]  C. Zuo, Q. Chen, N. Liu, J. Ren, and X. Sui , "Display and detail
% enhancement for high-dynamic-range infrared images", Opt. Eng. 50, 127401 (2011); 

clc;
close all;
clear;

%%load one test HDR image
% 1.mat / 2.mat
load('1.mat');


% here we just use a common Guassian filter to remove gradient reversal.
% Although it is not so accurate as adaptive Guassian filter, but it is
% much faster and the final result is acceptable.

gauss_filter=fspecial('gaussian',3,1);

dr=25;
%  use fast BF to get the base image and weight 
[BFF,w]=bilateralFilter(double(I),double(I),[],[],10,25,10,20); 
%  U can aslo use raw BF to get the base image and weight, it is more
%  accurate but more time-consuming
% [BFF,w]=bfilter16(double(I),20,[10,dr] ); 

% refine the base layer to prevent gradient reversal.
BF=imfilter(BFF,gauss_filter,'replicate');

% get the detail layer.
R=I-BF;

% histogram projection for base layer
HISTBF=HISTP(uint16(BF),81);

RR=mat2gray(R,[-dr,dr])*dr*2;

% AGC result
RAW=mat2gray(scopemat(uint16(I)));
% automate gain control for detail layer and add back to base
% Gmax=2.5 Gmin=1 this parameter is adjustable.
OUT=mat2gray(double(HISTBF+(1.5*(1-w)+1).*RR));
subplot(1,2,1);
imshow(RAW);
subplot(1,2,2);
imshow(OUT);
